
//+------------------------------------------------------------------+
//|                                 ind - Profitunity AO Signals.mq4 |
//| Fractals                                                         |
//|                                                                  |
//|                                        Converted by Mql2Mq4 v0.7 |
//|                                            http://yousky.free.fr |
//|                                    Copyright  2006, Yousky Soft |
//+------------------------------------------------------------------+

#property copyright " Copyright  2003, Alexey Zerg"
#property link      " http://profitunity.com.ru"

#property indicator_chart_window
#property indicator_color1 Blue
#property indicator_buffers 2
#property indicator_color2 Red

extern string TimeFrame = "Current time frame";  
extern bool   Sig1=true;
extern bool   Sig2=true;
extern bool   Sig3=true;
extern int    ArrowDis=1;
extern double nAccountedBars = 300;

extern bool   Change_Arrow = true;

string indicatorFileName;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+
//| Common External variables                                        |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| External variables                                               |
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
//| Special Convertion Functions                                     |
//+------------------------------------------------------------------+

int LastTradeTime;
double ExtHistoBuffer[];
double ExtHistoBuffer2[];

void SetLoopCount(int loops)
{
}

void SetIndexValue(int shift, double value)
{
  ExtHistoBuffer[shift] = value;
}

void SetIndexValue2(int shift, double value)
{
  ExtHistoBuffer2[shift] = value;
}

//+------------------------------------------------------------------+
//| End                                                              |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Initialization                                                   |
//+------------------------------------------------------------------+

int init()
  {
  int co;
   SetIndexStyle(0, DRAW_ARROW, STYLE_SOLID);
   SetIndexBuffer(0, ExtHistoBuffer);
   if(Change_Arrow) co = 233; else co = 251;
   SetIndexArrow(0,co); 
   SetIndexStyle(1, DRAW_ARROW, STYLE_SOLID);
   SetIndexBuffer(1, ExtHistoBuffer2);
      if(Change_Arrow) co = 234; else co = 251;
   SetIndexArrow(1,co);

   SetIndexLabel(0,NULL);
   SetIndexLabel(1,NULL);
  
   indicatorFileName = WindowExpertName();
   returnBars        = TimeFrame == "returnBars";     if (returnBars)     return(0);
   timeFrame         = stringToTimeFrame(TimeFrame);
   IndicatorShortName(timeFrameToString(timeFrame)+" AO-Signals");
   return(0);
}
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { ExtHistoBuffer[0] = limit+1; return(0); }
   
            if (timeFrame!=Period())
            {
               limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
               for (int i=limit; i>=0; i--)
               {
                  int y = iBarShift(NULL,timeFrame,Time[i]);             
                     ExtHistoBuffer[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Sig1,Sig2,Sig3,ArrowDis,nAccountedBars,0,y);
                     ExtHistoBuffer2[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Sig1,Sig2,Sig3,ArrowDis,nAccountedBars,1,y);
               }
               return(0);
            }
//+------------------------------------------------------------------+
//| Local variables                                                  |
//+------------------------------------------------------------------+
int CurrentBar = 0;
double price = 0;
double n = 0;
double k = 0;

/*[[
    Name := Profitunity AO Signals
	Author := Copyright  2003, Alexey Zerg
	Link := http://profitunity.com.ru
    Notes := Fractals
    Separate Window := No
    First Color := Blue
    First Draw Type := Symbol
    First Symbol := 110
    Use Second Data := Yes
    Second Color := Red
    Second Draw Type := Symbol
    Second Symbol := 110
]]*/



SetLoopCount(0);

k = (((High[1]-Low[1])+(High[2]-Low[2])+(High[3]-Low[3])+(High[4]-Low[4])+(High[5]-Low[5]))/5)/3;

for(CurrentBar =0;CurrentBar <=nAccountedBars ;CurrentBar ++){ 

//  
if( iAO(NULL, 0, CurrentBar) >= 0 && iAO(NULL, 0, CurrentBar+1) < 0 && Sig1==true) 
{
SetIndexValue(CurrentBar, Low[CurrentBar]-k-ArrowDis*Point);
}




if( iAO(NULL, 0, CurrentBar) <= 0 && iAO(NULL, 0, CurrentBar+1) > 0 && Sig1==true) 
{
SetIndexValue2(CurrentBar, High[CurrentBar]+k+ArrowDis*Point);
}


if( iAO(NULL, 0, CurrentBar) > iAO(NULL, 0, CurrentBar+1) && iAO(NULL, 0, CurrentBar+1) < iAO(NULL, 0, CurrentBar+2)) 
{
 if( iAO(NULL, 0, CurrentBar) > 0  && Sig2==true) 
 {
  SetIndexValue(CurrentBar, Low[CurrentBar]-k-ArrowDis*Point);
 }
  else 
 {
  n=1;
  while( iAO(NULL, 0, CurrentBar+n) < 0) 
  {
  if( iAO(NULL, 0, CurrentBar+n) > iAO(NULL, 0, CurrentBar+1+n) && iAO(NULL, 0, CurrentBar+1+n) < iAO(NULL, 0, CurrentBar+2+n) && iAO(NULL, 0, CurrentBar+n) < iAO(NULL, 0, CurrentBar)  && Sig3==true) 
  {
   SetIndexValue(CurrentBar, Low[CurrentBar]-k-ArrowDis*Point);
   break;
  }
  n = n+1;
  }
 }
}

if( iAO(NULL, 0, CurrentBar) < iAO(NULL, 0, CurrentBar+1) && iAO(NULL, 0, CurrentBar+1) > iAO(NULL, 0, CurrentBar+2) ) 
{
 if( iAO(NULL, 0, CurrentBar) < 0  && Sig2==true) 
 {
  SetIndexValue2(CurrentBar, High[CurrentBar]+k+ArrowDis*Point);
 }
  else 
 {
  n=1;
  while( iAO(NULL, 0, CurrentBar+n) > 0
  ) {
  if( iAO(NULL, 0, CurrentBar+n) < iAO(NULL, 0, CurrentBar+1+n) && iAO(NULL, 0, CurrentBar+1+n) > iAO(NULL, 0, CurrentBar+2+n) && iAO(NULL, 0, CurrentBar+n) > iAO(NULL, 0, CurrentBar)  && Sig3==true) 
  {
   SetIndexValue2(CurrentBar, High[CurrentBar]+k+ArrowDis*Point);
   break;
  }
  n = n+1;
  }
 }
}

}   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}


